/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package messagelistenerconsumerclient;

import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.InitialContext;
import javax.naming.NamingException;

/**
 * Simple messageListener class which can be used to consume all messages from INPUT.Q
 * @author slossr1
 */
public class MessageListenerConsumer {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
       MessageListenerConsumer mlc = new MessageListenerConsumer();
       mlc.startConsuming();
    }

    public void startConsuming() {
        InitialContext ictx;
        QueueConnectionFactory cf;
        Queue q;
        QueueConnection conn;
        QueueSession session;
        MessageConsumer mc;

        try {
            ictx = new InitialContext();
            cf = (QueueConnectionFactory) ictx.lookup("jms/XA_Connection_Factory");
            q = (Queue) ictx.lookup("jndi/INPUT.Q");
            conn = cf.createQueueConnection();
            session = conn.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
            mc = session.createConsumer((Destination)q);
            MyListenerSimple listener = new MyListenerSimple();
            mc.setMessageListener(listener);
            conn.start();

            System.in.read(); // waiting for messages

            session.close();
            conn.close();
        } catch (IOException ex) {
            Logger.getLogger(MessageListenerConsumer.class.getName()).log(Level.SEVERE, null, ex);
        } catch (JMSException ex) {
            Logger.getLogger(MessageListenerConsumer.class.getName()).log(Level.SEVERE, null, ex);
        } catch (NamingException ex) {
            Logger.getLogger(MessageListenerConsumer.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    class MyListenerSimple implements javax.jms.MessageListener
    {
        MyListenerSimple() {}

        public void onMessage(javax.jms.Message msg) {
          try {
              if(msg==null)
                System.out.println("Message: message null ");
              else {
                if(msg instanceof ObjectMessage) {
                    String m = (String) ((ObjectMessage)msg).getObject();
                    System.out.println ("JMS client: received message ======> " + m);
                } else if(msg instanceof TextMessage) {
                    String m = ((TextMessage)msg).getText();
                    System.out.println ("JMS client: received message ======> " + m);
                }
              }
          } catch(Exception exc) {
              System.out.println("Exception caught :" + exc);
              exc.printStackTrace();
          }
        }
    }

}

